Index: pplinux/linuxnew/arch/ppc/kernel/ppc4xx_i2c.c
diff -u /dev/null pplinux/linuxnew/arch/ppc/kernel/ppc4xx_i2c.c:1.2
--- /dev/null	Tue May 24 10:37:58 2005
+++ pplinux/linuxnew/arch/ppc/kernel/ppc4xx_i2c.c	Fri Apr 29 10:43:28 2005
@@ -0,0 +1,475 @@
+/*****************************************************************************/
+/* I2C Bus interface initialisation and I2C Commands                         */
+/* for PPC405GP		                                                     */
+/* Author : AS HARNOIS                                                       */
+/* Date   : 13.Dec.00                                                        */
+/*****************************************************************************/
+
+#include <linux/config.h>
+#include <linux/delay.h>
+#include <linux/init.h>
+#include <linux/smp.h>
+#include <linux/threads.h>
+#include <linux/spinlock.h>
+
+#include <asm/system.h>
+#include <linux/interrupt.h>
+
+#include <linux/param.h>
+#include <linux/string.h>
+#include <linux/blk.h>
+#include <linux/pci.h>
+#include <linux/rtc.h>
+#include <linux/console.h>
+#include <linux/ide.h>
+
+#include <asm/processor.h>
+#include <asm/ibm4xx.h>
+#include <asm/machdep.h>
+#include <asm/page.h>
+#include <asm/kgdb.h>
+#include <asm/time.h>
+#include <asm/ppc4xx_i2c.h>
+
+#ifdef DEBUG
+# define D(fmt, args...)	{ printk(fmt, ##args); }
+#else
+# define D(fmt, args...)	{ }
+#endif
+
+static void out8(void *ptr, unsigned char val){
+ /* Ensure I/O operations complete */
+/* __asm__ volatile("eieio");
+ * writeb has internal eieio
+ */
+
+   writeb(val, ptr);
+		
+}
+
+static unsigned char in8(void *ptr){
+
+   return readb(ptr);
+}
+
+
+void i2c_init(void)
+{
+  bd_t* bd = (bd_t*)__res;
+  int divisor;
+
+  D("I2C_INIT\n");
+  /* clear lo master address */
+  out8(IIC_LMADR,0);
+  /* clear hi master address */
+  out8(IIC_HMADR,0);
+  /* clear lo slave address */
+  out8(IIC_LSADR,0);
+  /* clear hi slave address */
+  out8(IIC_HSADR,0);
+
+  /* Reset status register */
+  /* write 1 in SCMP IRQA to clear these fields */
+  /* !!! ASH QpenBios says 0x08 */
+  /*  out8(IIC_STS, 0x0C);  */
+  out8(IIC_STS, 0x08);
+  /* write 1 in IRQP IRQD LA ICT XFRA to clear these fields */
+  out8(IIC_EXTSTS, 0x8F);
+
+
+  /* Clock divide Register */
+  
+  /* set divisor according to OPB frequency */
+  if (bd->bi_opb_busfreq <= 20000000)
+    divisor = 0x1;
+  else if (bd->bi_opb_busfreq <= 30000000)
+    divisor = 0x2;
+  else if (bd->bi_opb_busfreq <= 40000000)
+    divisor = 0x3;
+  else if (bd->bi_opb_busfreq <= 50000000)
+    divisor = 0x4;
+  else
+    divisor = 0x5;
+  out8(IIC_CLKDIV,divisor);
+
+  /* no interrupts */
+  out8(IIC_INTRMSK,0);
+
+  /* clear transfer count */
+  out8(IIC_XFRCNT,0);
+
+
+  /* clear extended control & stat */
+  /* write 1 in SRC SRS SWC SWS to clear these fields */
+  out8(IIC_XTCNTLSS,0xF0);
+
+
+  /* Mode Control Register
+     Flush Slave/Master data buffer
+     Ignore General Call, 100kHz, slave transfers are ignored,
+     disable interrupts, exit unknown bus state, enable hold
+     SCL
+  */
+  out8(IIC_MDCNTL, IIC_MDCNTL_FSDB | IIC_MDCNTL_FMDB | IIC_MDCNTL_EUBS);
+
+
+//  out8(IIC_MDCNTL, ((in8(IIC_MDCNTL))|IIC_MDCNTL_EUBS|IIC_MDCNTL_HSCL));
+//sand
+//  out8(IIC_MDCNTL, (IIC_MDCNTL_EUBS);
+//
+
+  /* clear control reg */
+  out8(IIC_CNTL,0x00);
+
+
+}
+
+
+static int i2c_transfer(unsigned char command_is_reading, unsigned char address,
+		 unsigned short size_to_transfer, unsigned char data[] )
+{
+  bd_t* bd = (bd_t*)__res;
+  int bytes_transfered;
+  int result;
+  int status;
+  int i, TimeReady, TimeOut;
+
+  result = IIC_OK;
+  bytes_transfered = 0;
+
+  D("i2c transfer called\n");
+
+  /* Check init */
+  i=10;
+  do{
+    /* Get status */
+    status = in8(IIC_STS);
+
+    i--;
+  }while ((status & IIC_STS_PT) && (i>0));
+  if (status & IIC_STS_PT)
+    {
+      result = IIC_NOK_TOUT;
+      D("IIC_NOK_TOUT \n");
+      return(result);
+    }
+
+  /* 7-bit adressing */
+  out8(IIC_HMADR,0);
+
+  out8(IIC_LMADR, address);
+
+
+  /* In worst case, you need to wait 4 OPB clocks */
+  /* for data being ready on IIC bus */
+  /* (because FIFO is 4 bytes depth) */
+  TimeReady = (4/(bd->bi_procfreq/bd->bi_opb_busfreq)) + 1;
+
+  /* IIC time out => wait for TimeOut cycles */
+  /* TimeOut /= 2; because waiting-loop is 2-instruction loop */
+  TimeOut = bd->bi_procfreq*IIC_TIMEOUT;// * 10;
+  TimeOut /= 2;
+
+  while ((bytes_transfered < size_to_transfer) && (result == IIC_OK))
+    {
+      D("\niic transfer: write %d byte (size %d)\n",bytes_transfered, size_to_transfer);
+  
+      /* Control register =
+	 Normal transfer, 7-bits adressing, Transfer 1 byte, Normal start,
+	 Transfer is a sequence of transfers
+	 Write/Read, Start transfer */
+
+      /* ACTION => Start - Transfer - Ack - pause */
+      /* ACTION - LAST BYTE => Start - Transfer - Nack  - Stop */
+      if (command_is_reading)
+	{
+          D("iic transfer: read command\n");
+	  /* issue read command */
+	  if (bytes_transfered == size_to_transfer-1)
+	    {
+	    out8(IIC_CNTL, IIC_CNTL_READ | IIC_CNTL_PT);
+	
+	    }
+	  else
+	    {
+	      out8(IIC_CNTL, IIC_CNTL_READ | IIC_CNTL_CHT | IIC_CNTL_PT);
+	
+	    }
+	}
+      else
+	{
+          D("iic transfer: write command\n");
+	  /* Set buffer */
+	  out8(IIC_MDBUF,data[bytes_transfered]);
+	
+	  i=TimeReady;
+	  do{
+	    i--;
+	  }while(i>0);
+	  /* issue write command */
+	  if (bytes_transfered == size_to_transfer-1)
+	    {
+	    out8(IIC_CNTL, IIC_CNTL_PT);
+	
+	    }
+	  else
+	    {
+	    out8(IIC_CNTL, IIC_CNTL_CHT | IIC_CNTL_PT);
+	
+	    }
+	}
+
+	D("iic transfer in progress\n");
+      /* Transfer is in progress */
+      i=TimeOut;
+      do{
+	/* Get status */
+	status = in8(IIC_STS);
+	
+	i--;
+      }while ((status & IIC_STS_PT) && (i>0));
+
+      if (status & IIC_STS_PT)
+	{
+	  D("Transfer pending\n");	
+	  result = IIC_NOK_TOUT;
+	}
+      else if (status & IIC_STS_ERR)
+	{
+          D("iic transfer: IIC_STS_ERR\n");
+	  result = IIC_NOK;
+	  status = in8(IIC_EXTSTS);
+          D("iic transfer: IIC_EXTSTS: %02x\n",status);
+	
+	  /* Lost arbitration? */
+	  if (status & IIC_EXTSTS_LA)
+	    result = IIC_NOK_LA;
+	  /* Incomplete transfer? */
+	  if (status & IIC_EXTSTS_ICT)
+	    result = IIC_NOK_ICT;
+	  /* Transfer aborted? */
+	  if (status & IIC_EXTSTS_XFRA)
+	    result = IIC_NOK_XFRA;
+	}
+      /* Command is reading => get buffer */
+      if ((command_is_reading) && (result == IIC_OK))
+	{
+	  /* Are there data in buffer */
+	  if (status & IIC_STS_MDBS)
+	    {
+	      i=TimeReady;
+	      do{
+		i--;
+	      }while(i>0);
+	      data[bytes_transfered] = in8(IIC_MDBUF);
+	
+	    }
+	  else result = IIC_NOK_DATA;
+	}
+      bytes_transfered++;
+    }
+  D("iic transfer: bytes transfered: %d\n",bytes_transfered);
+  return(result);
+}
+
+
+int i2c_receive(unsigned char address,
+		 unsigned short size_to_expect, unsigned char datain[] )
+{
+  int status;
+  
+  status = i2c_transfer(1, address, size_to_expect, datain);
+#ifdef CONFIG_PEPPERCON
+  if (status != 0) {
+  	D("I2C error => status = %d\n", status);
+#if 0
+  	D("I2C error => status = %02x\n", in8(IIC_STS));
+  	D("I2C error => ext status = %02x\n", in8(IIC_EXTSTS));
+  	D("I2C error => transfer count  = %02x\n", in8(IIC_XFRCNT));
+  	D("I2C error => ext slave status = %02x\n", in8(IIC_XTCNTLSS));
+#endif
+  }
+#endif
+  return status;
+}
+
+
+int i2c_send(unsigned char address,
+		 unsigned short size_to_send, unsigned char dataout[] )
+{
+  int status;
+  status = i2c_transfer(0, address, size_to_send, dataout);
+#if defined(CONFIG_WALNUT405) || defined (CONFIG_PEPPERCON)
+  if (status != 0) {
+  	D("I2C error => status = %d\n", status);
+#if 0
+  	D("I2C error => status = %02x\n", in8(IIC_STS));
+  	D("I2C error => ext status = %02x\n", in8(IIC_EXTSTS));
+  	D("I2C error => transfer count  = %02x\n", in8(IIC_XFRCNT));
+  	D("I2C error => ext slave status = %02x\n", in8(IIC_XTCNTLSS));
+#endif
+  }
+#endif
+  return status;
+}
+
+
+int i2c_read (unsigned char *addr, int alen, unsigned char *buffer, int len)
+{
+	int ret = 0;
+
+	D ("I2C read: addr len %d len %x\n", alen, len);
+	if (alen == 2) {
+		ret = i2c_send(addr[0] << 1, 1, addr+1);
+		if (ret) return ret;
+		ret = i2c_receive ((addr[0] << 1) | 0x01, len, buffer);
+	}
+	else if (alen == 3) {
+		ret = i2c_send(addr[0] << 1, 2, addr+1);
+		if (ret) return ret;
+		ret = i2c_receive((addr[0] << 1) | 0x01, len, buffer);
+	} else{
+		D("I2C read: addr len %d not supported\n", alen);
+		ret = -1;
+	}
+	
+	return ret;
+}
+
+int i2c_write (unsigned char *addr, int alen, unsigned char *buffer, int len)
+{
+	unsigned char xbuf[3];
+//	unsigned char intaddr[2];
+	unsigned short eepaddr;
+	int timeout;
+
+	D ("I2C write: addr len %d len %x\n", alen,len);
+	if (alen == 2) {
+		/* write with ack polling */
+		/* XXX this should be improved to allow page write mode XXX - wd */
+		while (len-- > 0) {
+          		xbuf[0] = addr[1]++; /* increase write offset */
+          		xbuf[1] = *buffer++;
+          		while (i2c_send(addr[0] << 1, 2, xbuf) != 0) /* single write + ack polling */
+            		udelay(100);
+		}
+	}else if (alen == 3){
+		/* write with ack polling */
+		/* XXX this should be improved to allow page write mode XXX - wd */
+		eepaddr = addr[1];
+		eepaddr <<= 8;
+		eepaddr |= addr[2];
+		while (len-- > 0) {
+//          		D("\nwrite %02x to eep (%02x) address %02x%02x\n", xbuf[2],addr[0]<<1,xbuf[0],xbuf[1]);
+			xbuf[0] = eepaddr >> 8; /* increase write offset */
+          		xbuf[1] = (unsigned char) eepaddr & 0xFF;
+          		xbuf[2] = *buffer++;
+			eepaddr++;
+//          		D("write %02x to eep (%02x) address %02x%02x\n", xbuf[2],addr[0]<<1,xbuf[0],xbuf[1]);
+          		timeout = 0;
+          		while (i2c_send(addr[0] << 1, 3, xbuf) != 0){ /* single write + ack polling */
+            			udelay(100);
+            			timeout++;	
+            			if (timeout > 10) {
+            				D("I2C write timeout after %d * 100 udelays\n",timeout);
+            				return -1;
+            			}
+            		};
+//			D("I2C write need %d * 100 udelays\n",timeout);
+            		
+		}
+	}else {
+		D("I2C write: addr len %d not supported\n", alen);
+		return -1;
+	}
+
+	return 0;
+}
+
+/*-----------------------------------------------------------------------
+ */
+
+int rtc_read (unsigned offset, unsigned char *buffer, unsigned cnt)
+{
+	unsigned end = offset + cnt;
+	unsigned blk_off;
+	int ret;
+
+	D("RTC read\n");
+	/* Read data until done or would cross a page boundary.
+	 * We must write the address again when changing pages
+	 * because the next page may be in a different device.
+	 */
+	while (offset < end) {
+		unsigned alen, len, maxlen;
+		unsigned char addr[3];
+
+		blk_off = offset & 0xFF;	/* block offset */
+
+		addr[0] = offset >> 16;		/* block number */
+		addr[1] = offset >>  8;		/* upper address octet */
+		addr[2] = blk_off;		/* lower address octet */
+		alen	= 3;
+
+		addr[0] |= CFG_I2C_RTC_ADDR;	/* insert device address */
+
+		maxlen = 0x100 - blk_off;
+		len    = end - offset;
+		if (len > maxlen)
+			len = maxlen;
+
+		if ((ret = i2c_read(addr, alen, buffer, len))) {
+			return ret;
+		}
+		buffer += len;
+		offset += len;
+	}
+
+	return 0;
+}
+
+/*-----------------------------------------------------------------------
+ */
+
+int rtc_write (unsigned offset, unsigned char *buffer, unsigned cnt)
+{
+	unsigned end = offset + cnt;
+	unsigned blk_off;
+	int ret;
+
+	/* Write data until done or would cross a write page boundary.
+	 * We must write the address again when changing pages
+	 * because the address counter only increments within a page.
+	 */
+
+	D("RTC write\n");
+	while (offset < end) {
+		unsigned alen, len, maxlen;
+		unsigned char addr[3];
+
+		blk_off = offset & 0xFF;	/* block offset */
+
+		addr[0] = 0;			/* block number */
+		addr[1] = offset >>  8;		/* upper address octet */
+		addr[2] = blk_off;		/* lower address octet */
+		alen	= 3;
+
+		addr[0] |= CFG_I2C_RTC_ADDR;	/* insert device address */
+
+		maxlen = 0x100 - blk_off;
+		len = end - offset;
+		if (len > maxlen)
+			len = maxlen;
+
+		if ((ret = i2c_write(addr, alen, buffer, len))) {
+			return ret;
+		}
+		buffer += len;
+		buffer += len;
+		offset += len;
+	}
+
+	return 0;
+}
+
+
Index: pplinux/linuxnew/arch/ppc/kernel/ppc4xx_setup.c
diff -u pplinux/linuxnew/arch/ppc/kernel/ppc4xx_setup.c:1.1.323.1 pplinux/linuxnew/arch/ppc/kernel/ppc4xx_setup.c:1.2
--- pplinux/linuxnew/arch/ppc/kernel/ppc4xx_setup.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/kernel/ppc4xx_setup.c	Thu Feb  3 11:35:37 2005
@@ -236,7 +236,8 @@
 	bd_t *bip = (bd_t *) __res;
 
 #if defined(CONFIG_WALNUT) || defined(CONFIG_CEDER) 	\
-	|| defined(CONFIG_ASH) || defined(CONFIG_SYCAMORE)
+	|| defined(CONFIG_ASH) || defined(CONFIG_SYCAMORE) \
+	|| (defined(CONFIG_PEPPERCON) && !defined(CONFIG_405EP))
 	/* Openbios sets cpu  timers to CPU clk
 	 * we want to use the external clk
 	 * DCR CHCR1 (aka CPC0_CR1) bit CETE to 1 */
Index: pplinux/linuxnew/arch/ppc/kernel/ppc4xx_sgdma.c
diff -u pplinux/linuxnew/arch/ppc/kernel/ppc4xx_sgdma.c:1.1.323.1 pplinux/linuxnew/arch/ppc/kernel/ppc4xx_sgdma.c:1.2
--- pplinux/linuxnew/arch/ppc/kernel/ppc4xx_sgdma.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/kernel/ppc4xx_sgdma.c	Thu Feb  3 11:35:37 2005
@@ -31,7 +31,7 @@
 #include <asm/io.h>
 #include <asm/ppc4xx_dma.h>
 
-static __inline__ void
+void
 ppc4xx_set_sg_addr(int dmanr, phys_addr_t sg_addr)
 {
 	switch (dmanr) {
@@ -73,7 +73,7 @@
  *   memory to peripheral: set dst_addr to NULL,
  *   peripheral to memory: set src_addr to NULL.
  */
-static __inline__ int
+int
 ppc4xx_add_dma_sgl(sgl_handle_t handle, phys_addr_t src_addr, phys_addr_t dst_addr,
 		   unsigned int count)
 {
@@ -152,7 +152,7 @@
 /*
  * Enable (start) the DMA described by the sgl handle.
  */
-static __inline__ void
+void
 ppc4xx_enable_dma_sgl(sgl_handle_t handle)
 {
 	sgl_list_info_t *psgl = (sgl_list_info_t *) handle;
@@ -200,7 +200,7 @@
 /*
  * Halt an active scatter/gather DMA operation.
  */
-static __inline__ void
+void
 ppc4xx_disable_dma_sgl(sgl_handle_t handle)
 {
 	sgl_list_info_t *psgl = (sgl_list_info_t *) handle;
@@ -243,7 +243,7 @@
  *
  *  An sgl transfer must NOT be active when this function is called.
  */
-static __inline__ int
+int
 ppc4xx_get_dma_sgl_residue(sgl_handle_t handle, phys_addr_t * src_addr,
 			   phys_addr_t * dst_addr)
 {
@@ -346,7 +346,7 @@
  *
  * This function should only be called when the DMA is not active.
  */
-static __inline__ int
+int
 ppc4xx_delete_dma_sgl_element(sgl_handle_t handle, phys_addr_t * src_dma_addr,
 			      phys_addr_t * dst_dma_addr)
 {
@@ -382,6 +382,29 @@
 	return DMA_STATUS_GOOD;
 }
 
+/*
+ * Clear the scatter/gather list.
+ *
+ * This function should only be called when the DMA is not active.
+ */
+int
+ppc4xx_clear_dma_sgl(sgl_handle_t handle)
+{
+	sgl_list_info_t *psgl = (sgl_list_info_t *) handle;
+
+	if (!handle) {
+		printk("ppc4xx_delete_sgl_element: null handle\n");
+		return DMA_STATUS_BAD_HANDLE;
+	} else if (psgl->dmanr > (MAX_PPC4xx_DMA_CHANNELS - 1)) {
+		printk("ppc4xx_delete_sgl_element: bad channel in handle %d\n",
+		       psgl->dmanr);
+		return DMA_STATUS_BAD_CHANNEL;
+	}
+
+	psgl->phead = psgl->ptail = NULL;
+
+	return DMA_STATUS_GOOD;
+}
 
 /*
  *   Create a scatter/gather list handle.  This is simply a structure which
@@ -531,6 +554,7 @@
 EXPORT_SYMBOL(ppc4xx_free_dma_handle);
 EXPORT_SYMBOL(ppc4xx_add_dma_sgl);
 EXPORT_SYMBOL(ppc4xx_delete_dma_sgl_element);
+EXPORT_SYMBOL(ppc4xx_clear_dma_sgl);
 EXPORT_SYMBOL(ppc4xx_enable_dma_sgl);
 EXPORT_SYMBOL(ppc4xx_disable_dma_sgl);
 EXPORT_SYMBOL(ppc4xx_get_dma_sgl_residue);
Index: pplinux/linuxnew/arch/ppc/kernel/ppc_ksyms.c
diff -u pplinux/linuxnew/arch/ppc/kernel/ppc_ksyms.c:1.1.323.1 pplinux/linuxnew/arch/ppc/kernel/ppc_ksyms.c:1.2
--- pplinux/linuxnew/arch/ppc/kernel/ppc_ksyms.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/kernel/ppc_ksyms.c	Thu Feb  3 11:35:37 2005
@@ -199,6 +199,7 @@
 EXPORT_SYMBOL(consistent_sync);
 EXPORT_SYMBOL(consistent_sync_page);
 EXPORT_SYMBOL(flush_dcache_all);
+EXPORT_SYMBOL(invalidate_dcache_range);
 #endif
 
 EXPORT_SYMBOL(start_thread);
Index: pplinux/linuxnew/arch/ppc/kernel/setup.c
diff -u pplinux/linuxnew/arch/ppc/kernel/setup.c:1.1.323.1 pplinux/linuxnew/arch/ppc/kernel/setup.c:1.2
--- pplinux/linuxnew/arch/ppc/kernel/setup.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/kernel/setup.c	Thu Feb  3 11:35:37 2005
@@ -598,7 +598,7 @@
 			= cur_cpu_spec[0]->dcache_bsize;
 
 	/* reboot on panic */
-	panic_timeout = 180;
+	panic_timeout = 1;
 
 	init_mm.start_code = PAGE_OFFSET;
 	init_mm.end_code = (unsigned long) _etext;
Index: pplinux/linuxnew/arch/ppc/kernel/time.c
diff -u pplinux/linuxnew/arch/ppc/kernel/time.c:1.1.323.1 pplinux/linuxnew/arch/ppc/kernel/time.c:1.2
--- pplinux/linuxnew/arch/ppc/kernel/time.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/kernel/time.c	Thu Feb  3 11:35:37 2005
@@ -314,12 +314,15 @@
 	 * next second boundary to try to achieve some precision.  If there
 	 * is no RTC, we still need to set tb_last_stamp and
 	 * last_jiffy_stamp(cpu 0) to the current stamp.
+	 * time_offset == -1 (from time_init) means that init failed,
+	 * so don't read the time from rtc
+	 *
 	 */
 	stamp = get_native_tbl();
-	if (ppc_md.get_rtc_time) {
-		sec = ppc_md.get_rtc_time();
+	if (ppc_md.get_rtc_time && time_offset != -1) {
+		sec = old_sec = ppc_md.get_rtc_time();
 		elapsed = 0;
-		do {
+		while (sec != -1 && sec == old_sec && elapsed < 2*HZ*tb_ticks_per_jiffy) {
 			old_stamp = stamp;
 			old_sec = sec;
 			stamp = get_native_tbl();
@@ -327,8 +330,10 @@
 				old_stamp -= 1000000000;
 			elapsed += stamp - old_stamp;
 			sec = ppc_md.get_rtc_time();
-		} while ( sec == old_sec && elapsed < 2*HZ*tb_ticks_per_jiffy);
-		if (sec == old_sec)
+		}
+		if (sec == -1)
+			printk("Warning: could not read real time clock !\n");
+		else if (sec == old_sec)
 			printk("Warning: real time clock seems stuck!\n");
 		xtime.tv_sec = sec;
 		xtime.tv_usec = 0;
Index: pplinux/linuxnew/arch/ppc/kernel/traps.c
diff -u pplinux/linuxnew/arch/ppc/kernel/traps.c:1.1.323.1 pplinux/linuxnew/arch/ppc/kernel/traps.c:1.2
--- pplinux/linuxnew/arch/ppc/kernel/traps.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/kernel/traps.c	Thu Feb  3 11:35:37 2005
@@ -35,6 +35,7 @@
 #include <asm/system.h>
 #include <asm/io.h>
 #include <asm/processor.h>
+#include <asm/ppc405_pcimcs.h>
 #ifdef CONFIG_PMAC_BACKLIGHT
 #include <asm/backlight.h>
 #endif
@@ -76,11 +77,25 @@
 #endif
 #endif
 
+#if 0
+static
+void print_pci_config(void) {
+    int i;
+    printk("+++ PCI CONFIG SPACE DUMP from Machine Check Handler >>>\n");
+    for (i = 0; i < 0x78; i += 4) {
+	u32 val;
+	fix_pci_read_config_long(PPC405_PCI_CONFIG_ADDR,
+				  PPC405_PCI_CONFIG_DATA,
+				  i, &val);
+	printk("PCI Reg 0x%02x: 0x%08x\n", i, val);
+    }
+}
+#endif
+ 
 /*
  * Trap & Exception support
  */
 
-
 spinlock_t die_lock = SPIN_LOCK_UNLOCKED;
 
 void die(const char * str, struct pt_regs * fp, long err)
@@ -103,10 +118,20 @@
 	force_printk_to_btext = 0;
 #endif
 	spin_unlock_irq(&die_lock);
+#ifdef CONFIG_PEPPERCON
+	/*
+	 * we need to die completely for the moment as killing
+	 * a faulty thread is not handled currently.
+	 * that means we unconditionally panic even if it 
+	 * is just a normal task that has caused the machine check
+	 */
+	panic("Ufff, I'll better give up and try again!");
+#else 
 	/* do_exit() should take care of panic'ing from an interrupt
 	 * context so we don't handle it here
 	 */
 	do_exit(err);
+#endif
 }
 
 void
@@ -137,7 +162,78 @@
  */
 static inline int check_io_access(struct pt_regs *regs)
 {
-#ifdef CONFIG_ALL_PPC
+#if defined(CONFIG_PEPPERCON)
+	unsigned long fixup;
+
+	if ((fixup = search_exception_table(regs->nip)) != 0) {
+		regs->nip = fixup;
+		return 1;
+	}
+		
+	/* This may happen in eRIC for obscure reasons in cases
+	   where the VGA resource is not available any longer.
+	   Usually this kind of problem should be caught by the
+	   exception fixup (see above) but sometime it doesn't. 
+	   This can be detected by a PCI Master abort. In this case
+	   we try to resume by simply redoing the current instruction */
+	{
+		u16 sts;
+		u8 errsts;
+		u32 besr0;
+		u32 besr1;
+		u32 eaddr;
+		// printk(KERN_ALERT "Machine Check: NIP= 0x%lx\n", regs->nip);
+		// print pci config space
+		// print_pci_config();
+	    
+		// check whether it is a PCI Master Abort, that means
+		// it is most probably caused be a missing device in
+		// our host system, because of power off
+		fix_pci_read_config_word(PPC405_PCI_CONFIG_ADDR,
+					 PPC405_PCI_CONFIG_DATA,
+					 0x06  /*PCI_STATUS*/, &sts);
+		if (0 != (sts & PCI_STATUS_REC_MASTER_ABORT)) {
+			fix_pci_read_config_long(PPC405_PCI_CONFIG_ADDR,
+						 PPC405_PCI_CONFIG_DATA,
+						 0x54 /*PCIC0_PLBBEAR*/,
+						 &eaddr);
+			printk(KERN_ALERT "eRIC MC-handler: PCI Master Abort at 0x%x,"
+			       "NIP=0x%lx, resuming...\n", eaddr, regs->nip);
+			// clear all possible PCI errors
+			fix_pci_write_config_word(PPC405_PCI_CONFIG_ADDR,
+						  PPC405_PCI_CONFIG_DATA,
+						  0x06 /*PCI_STATUS*/, sts);
+			fix_pci_read_config_byte(PPC405_PCI_CONFIG_ADDR,
+						 PPC405_PCI_CONFIG_DATA,
+						 0x49  /*PCICO_ERRSTS*/,
+						 &errsts);
+			fix_pci_write_config_byte(PPC405_PCI_CONFIG_ADDR,
+						  PPC405_PCI_CONFIG_DATA,
+						  0x49 /*PCICO_ERRSTS*/,
+						  errsts);
+			fix_pci_read_config_long(PPC405_PCI_CONFIG_ADDR,
+						 PPC405_PCI_CONFIG_DATA,
+						 0x4c /*PCICO_PLBBESR0*/,
+						 &besr0);
+			fix_pci_write_config_long(PPC405_PCI_CONFIG_ADDR,
+						  PPC405_PCI_CONFIG_DATA,
+						  0x4c/*PCICO_PLBBESR0*/,
+						  besr0);
+			fix_pci_read_config_long(PPC405_PCI_CONFIG_ADDR,
+						 PPC405_PCI_CONFIG_DATA,
+						 0x50 /*PCICO_PLBBESR1*/,
+						 &besr1);
+			fix_pci_write_config_long(PPC405_PCI_CONFIG_ADDR,
+						  PPC405_PCI_CONFIG_DATA,
+						  0x50/*PCICO_PLBBESR1*/,
+						  besr1);
+			// try to resume
+			// THAT'S A SERIOUS HACK !!!!!!!!!!!
+			// let's see wether it's going to work
+			return 1;
+		}
+	}
+#elif defined(CONFIG_ALL_PPC)
 	unsigned long fixup;
 	unsigned long msr = regs->msr;
 
@@ -169,6 +265,7 @@
 			return 1;
 		}
 	}
+
 #endif /* CONFIG_ALL_PPC */
 	return 0;
 }
Index: pplinux/linuxnew/arch/ppc/platforms/Makefile
diff -u pplinux/linuxnew/arch/ppc/platforms/Makefile:1.1.323.1 pplinux/linuxnew/arch/ppc/platforms/Makefile:1.2
--- pplinux/linuxnew/arch/ppc/platforms/Makefile:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/platforms/Makefile	Thu Feb  3 11:35:37 2005
@@ -23,7 +23,7 @@
 O_TARGET := platform.o
 
 export-objs			:= prep_setup.o beech.o ibm405lp.o arctic2.o \
-				   mpc8260_pci9.o ibm440gp.o ibm440gx.o
+				   mpc8260_pci9.o ibm440gp.o ibm440gx.o peppercon.o
 
 obj-$(CONFIG_405GP)		+= ibm405gp.o
 obj-$(CONFIG_405LP)		+= ibm405lp.o
@@ -94,6 +94,7 @@
 obj-$(CONFIG_SANDPOINT)		+= sandpoint_setup.o sandpoint_pci.o
 obj-$(CONFIG_SPRUCE)		+= spruce_setup.o spruce_pci.o cpc700_pic.o
 obj-$(CONFIG_HXEB100)		+= hxeb100.o
+obj-$(CONFIG_PEPPERCON)		+= peppercon.o
 
 ifeq ($(CONFIG_SMP),y)
 obj-$(CONFIG_ALL_PPC)		+= pmac_smp.o chrp_smp.o
Index: pplinux/linuxnew/arch/ppc/platforms/ibm405ep.c
diff -u pplinux/linuxnew/arch/ppc/platforms/ibm405ep.c:1.1.323.1 pplinux/linuxnew/arch/ppc/platforms/ibm405ep.c:1.2
--- pplinux/linuxnew/arch/ppc/platforms/ibm405ep.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/platforms/ibm405ep.c	Thu Feb  3 11:35:37 2005
@@ -31,7 +31,7 @@
 	.mal_tx1_chan	= 0,		/* MAL tx channel 1 number */
 	.mal_tx2_chan	= 1,		/* MAL tx channel 2 number */
 	.wol_irq	= BL_MAC_WOL,	/* WOL interrupt number */
-	.mdio_idx	= -1,		/* No shared MDIO */
+	.mdio_idx	= 0,		/* No shared MDIO */
 };
 
 // FIXME: Check WOL IRQ
@@ -43,15 +43,15 @@
 	.mal_tx1_chan	= 2,		/* MAL tx channel 1 number */
 	.mal_tx2_chan	= 3,		/* MAL tx channel 2 number */
 	.wol_irq	= BL_MAC_WOL,	/* WOL interrupt number */
-	.mdio_idx	= -1,		/* No shared MDIO */
+	.mdio_idx	= 0,		/* No shared MDIO */
 };
 
 static struct ocp_func_mal_data ibm405ep_mal0_def = {
-	.num_tx_chans	= 2*EMAC_NUMS,	/* Number of TX channels */
-	.num_rx_chans	= EMAC_NUMS,	/* Number of RX channels */
+	.num_tx_chans	= 4,	/* Number of TX channels */
+	.num_rx_chans	= 2,	/* Number of RX channels */
 };
 
-struct ocp_def core_ocp[]  __initdata = {
+struct ocp_def core_ocp[]  = {
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_OPB,
 	  .index	= 0,
@@ -103,7 +103,7 @@
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_EMAC,
 	  .index	= 1,
-	  .paddr	= EMAC0_BASE,
+	  .paddr	= EMAC1_BASE,
 	  .irq		= BL_MAC_ETH1,
 	  .pm		= OCP_CPM_NA,
 	  .additions	= &ibm405ep_emac1_def,
Index: pplinux/linuxnew/arch/ppc/platforms/ibm405ep.h
diff -u pplinux/linuxnew/arch/ppc/platforms/ibm405ep.h:1.1.323.1 pplinux/linuxnew/arch/ppc/platforms/ibm405ep.h:1.2
--- pplinux/linuxnew/arch/ppc/platforms/ibm405ep.h:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/platforms/ibm405ep.h	Thu Feb  3 11:35:37 2005
@@ -55,6 +55,8 @@
 #define PPC4xx_ONB_IO_VADDR	PPC4xx_ONB_IO_PADDR
 #define PPC4xx_ONB_IO_SIZE	((uint)4*1024)
 
+#define OPB_BASE_START  0x40000000
+
 /* serial port defines */
 #define RS_TABLE_SIZE	2
 
Index: pplinux/linuxnew/arch/ppc/platforms/ibm405gp.c
diff -u pplinux/linuxnew/arch/ppc/platforms/ibm405gp.c:1.1.323.1 pplinux/linuxnew/arch/ppc/platforms/ibm405gp.c:1.2
--- pplinux/linuxnew/arch/ppc/platforms/ibm405gp.c:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/platforms/ibm405gp.c	Thu Feb  3 11:35:37 2005
@@ -53,7 +53,7 @@
 	.num_rx_chans	= EMAC_NUMS,	/* Number of RX channels */
 };
 
-struct ocp_def core_ocp[]  __initdata = {
+struct ocp_def core_ocp[]  = {
 	{ .vendor	= OCP_VENDOR_IBM,
 	  .function	= OCP_FUNC_OPB,
 	  .index	= 0,
Index: pplinux/linuxnew/arch/ppc/platforms/ibm405gp.h
diff -u pplinux/linuxnew/arch/ppc/platforms/ibm405gp.h:1.1.323.1 pplinux/linuxnew/arch/ppc/platforms/ibm405gp.h:1.2
--- pplinux/linuxnew/arch/ppc/platforms/ibm405gp.h:1.1.323.1	Thu Feb  3 10:00:25 2005
+++ pplinux/linuxnew/arch/ppc/platforms/ibm405gp.h	Thu Feb  3 11:35:37 2005
@@ -104,7 +104,11 @@
 
 #define IIC_OWN		0x55
 #define IIC_CLOCK	50
-#define BD_EMAC_ADDR(e,i) bi_enetaddr[i]
+#ifdef CONFIG_PEPPERCON
+# define BD_EMAC_ADDR(e,i) bi_enetaddr[e][i]
+#else
+# define BD_EMAC_ADDR(e,i) bi_enetaddr[i]
+#endif
 
 #define STD_UART_OP(num)					\
 	{ 0, BASE_BAUD, 0, UART##num##_INT,			\
